#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__='atareao'
__date__ ='$10-abr-2010 12:34:44$'
#
# <one line to give the program's name and a brief idea of what it does.>
#
# Copyright (C) 2009 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import sqlobject
from sqlobject import *
import os
import sys
import gtk
import ConfigParser
import locale
import gettext

APP = 'picapy'
DIR = '/usr/share/locale-langpack'

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(APP, DIR)
gettext.textdomain(APP)
_ = gettext.gettext

class Magnitud(sqlobject.SQLObject):
    nombre = sqlobject.StringCol(unique=True)
    nota = sqlobject.StringCol()
    unidades = MultipleJoin('Unidad')


class Unidad(sqlobject.SQLObject):
    nombre = sqlobject.StringCol(unique=True)
    simbolo = sqlobject.StringCol()
    factor = sqlobject.FloatCol()
    formula = sqlobject.StringCol()
    derivada = sqlobject.BoolCol()
    nota = sqlobject.StringCol()
    magnitud = ForeignKey('Magnitud',cascade=True)
    
class Ini:
    def __init__(self,inifile):
	self.inifile=inifile
	self.magnitud=''
	self.de=''
	self.a=''
	if os.path.exists(inifile)==False:
		self.write()
    def read(self):
	ini=ConfigParser.ConfigParser()
	ini.read(self.inifile)
	if not ini.has_section('Defecto'):
	    self.write()
	else:
	    self.magnitud=ini.get('Defecto','Magnitud')
	    self.de=ini.get('Defecto','De')
	    self.a=ini.get('Defecto','A')
    def write(self):
	ini=ConfigParser.ConfigParser()
	ini.read(self.inifile)
	if not ini.has_section('Defecto'):
		ini.add_section('Defecto')
	ini.set('Defecto','Magnitud',self.magnitud)
	ini.set('Defecto','De',self.de)
	ini.set('Defecto','A',self.a)
	with open(self.inifile,'wb') as writefile:
		ini.write(writefile)
    def get_magnitud(self):
	return self.magnitud
    def get_de(self):
	return self.de
    def get_a(self):
	return self.a
    def set_magnitud(self,magnitud):
	self.magnitud=magnitud
    def set_de(self,de):
	self.de=de
    def set_a(self,a):
	self.a=a
	
class MainWindow:
    def __init__(self):
	if os.path.exists(os.path.join(os.getenv("HOME"),".equivalpy/"))==False:
		os.mkdir(os.path.join(os.getenv("HOME"),".equivalpy/"))
	filename = os.path.join(os.getenv("HOME"),".equivalpy/equivalpy.ini")
	self.ini=Ini(filename)
	self.ini.read()

	self.builder = gtk.Builder()
	self.builder.add_from_file('/usr/share/equivalpy/pantalla_principal.glade')
	self.window = self.builder.get_object('window')
	self.entry1 = self.builder.get_object('entry1')
	self.entry2 = self.builder.get_object('entry2')
	self.combobox1 = self.builder.get_object('combobox1')
	self.liststore1 = self.builder.get_object('liststore1')
	self.combobox2 = self.builder.get_object('combobox2')
	self.combobox3 = self.builder.get_object('combobox3')
	db_filename = os.path.abspath('/usr/share/equivalpy/equival.sqlite')
	connection_string = 'sqlite:'+db_filename
	connection = connectionForURI(connection_string)
	sqlhub.processConnection = connection    
	# a ver si as funciona
	model = gtk.ListStore(str)
	magnitudes=Magnitud.select(Magnitud.q.id>0)
	for magnitud in magnitudes:
		model.append([magnitud.nombre])
	self.combobox1.set_model(model)
	cell = gtk.CellRendererText()
	self.combobox1.pack_start(cell,True);
	self.combobox1.add_attribute(cell,'text',0)
	self.combobox1.set_active(0)
	self.set_unidad_de(magnitudes[0].nombre)
	self.set_unidad_a(magnitudes[0].nombre)
	self.window.show_all()
	self.on_ini_load()
	# Magia :P
	self.builder.connect_signals(self)

    def on_entry1_changed(self,widget):
	self.on_unidad_changed()

    def on_entry2_changed(self,widget):
	print ''
	#self.entry1.set_text(self.entry2.get_text())      

    def on_window_destroy(self,widget):
	exit(0)

    def get_unidad_posicion(self,q_magnitud,q_unidad):
	magnitud = Magnitud.select(Magnitud.q.nombre==q_magnitud)
	unidades = Unidad.select(Unidad.q.magnitud==magnitud[0].id)
	contador=0
	for unidad in unidades:
	    if unidad.nombre==q_unidad:
		    return contador
	    contador=contador+1
	return 0

    def get_magnitud_posicion(self,q_magnitud):
	magnitudes = Magnitud.select(Magnitud.q.id>0)
	contador=0
	for magnitud in magnitudes:
	    if magnitud.nombre==q_magnitud:
		return contador
	    contador=contador+1
	return 0

    def on_combobox1_changed(self,widget):
	self.set_magnitud(self.combobox1.get_active_text())

    def set_magnitud(self,magnitudval):
	magnitud = Magnitud.select(Magnitud.q.nombre==magnitudval)
	self.set_unidad_de(magnitud[0].id)
	self.set_unidad_a(magnitud[0].id)
	self.ini.set_a(self.combobox3.get_active_text())
	self.ini.set_de(self.combobox2.get_active_text())
	self.ini.set_magnitud(self.combobox1.get_active_text())
	self.ini.write()	

    def set_unidad_de(self,magnitudval):
	unidades = Unidad.select(Unidad.q.magnitud==magnitudval)
	self.combobox2.clear()
	model=gtk.ListStore(str)
	for unidad in unidades:
	    model.append([unidad.nombre])
	self.combobox2.set_model(model)
	cell=gtk.CellRendererText()
	self.combobox2.pack_start(cell,True)
	self.combobox2.add_attribute(cell,'text',0)
	self.combobox2.set_active(0)

    def set_unidad_a(self,magnitudval):
	unidades = Unidad.select(Unidad.q.magnitud==magnitudval)
	self.combobox3.clear()
	model=gtk.ListStore(str)
	for unidad in unidades:
	    model.append([unidad.nombre])
	self.combobox3.set_model(model)
	cell=gtk.CellRendererText()
	self.combobox3.pack_start(cell,True)
	self.combobox3.add_attribute(cell,'text',0)
	self.combobox3.set_active(0)

    def on_imagemenuitem5_activate(self,widget):
	exit(0)

    def on_imagemenuitem10_activate(self,widget):
	ad=gtk.AboutDialog()
	ad.set_name('EquivalPy')
	ad.set_version('0.3')
	ad.set_copyright('Copyrignt (c) 2010\nLorenzo Carbonell')
	ad.set_comments(_('An application to convert units'))
	ad.set_license(_(''+
	'This program is free software: you can redistribute it and/or modify it\n'+
	'under the terms of the GNU General Public License as published by the\n'+
	'Free Software Foundation, either version 3 of the License, or (at your option)\n'+
	'any later version.\n\n'+
	'This program is distributed in the hope that it will be useful, but\n'+
	'WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY\n'+
	'or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for\n'+
	'more details.\n\n'+
	'You should have received a copy of the GNU General Public License along with\n'+
	'this program.  If not, see <http://www.gnu.org/licenses/>.'))		
	ad.set_website('http://www.atareao.es')
	ad.set_website_label('http://www.atareao.es')
	ad.set_authors(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
	ad.set_documenters(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
	#ad.set_logo(logo)
	#ad.set_logo_icon_name(icon_name)
	ad.set_program_name('EquivalPy')
	ad.run()
	ad.hide()

    def on_ini_load(self):
	if self.ini.get_magnitud()=='':
	    self.ini.set_a(self.combobox3.get_active_text())
	    self.ini.set_de(self.combobox2.get_active_text())
	    self.ini.set_magnitud(self.combobox1.get_active_text())
	    self.ini.write()
	m=self.ini.get_magnitud()
	de=self.ini.get_de()
	a=self.ini.get_a()
	self.set_magnitud(m)
	self.combobox1.set_active(self.get_magnitud_posicion(m))
	self.combobox2.set_active(self.get_unidad_posicion(m,de))
	self.combobox3.set_active(self.get_unidad_posicion(m,a))
    
    def on_unidad_changed(self):
	if self.combobox2.get_active_text()!=None and self.combobox3.get_active_text()!=None:
	    unidad1 = Unidad.select(Unidad.q.nombre==self.combobox2.get_active_text())
	    unidad2 = Unidad.select(Unidad.q.nombre==self.combobox3.get_active_text())
	    factor=unidad1[0].factor/unidad2[0].factor
	    valor=self.entry1.get_text()
	    self.entry2.set_text(str(self.toFloat(valor)*factor))
	    self.entry1.set_text(valor)		
	    self.ini.set_magnitud(self.combobox1.get_active_text())
	    self.ini.set_de(self.combobox2.get_active_text())
	    self.ini.set_a(self.combobox3.get_active_text())
	    self.ini.write()

    def on_combobox2_changed(self,widget):
	self.on_unidad_changed()

    def on_combobox3_changed(self,widget):
	self.on_unidad_changed()

    def toFloat(self,valor):
	if len(valor)>0:
	    return float(valor)
	else:
	    return 0
	
if __name__ == '__main__':
    v = MainWindow()
    gtk.main()
